# -*- perl -*-
# $Id: fortunespub.pm,v 1.2 2009/04/24 14:43:29 cbellot Exp $

package modules::fortunespub;
my $modulename = "fortunespub";

use fortunes;
no utf8;

sub new {
    my $self = {};
    bless $self;
    return $self;
}
sub load { main::dprint "## ".$modulename."::load : loading"; }
sub unload { main::dprint "## ".$modulename."::unload : unloading"; }


sub cmd_bachib {
    my ($pkg, $conn, $event, $command, $to) = @_;
    my $rep = fortune("$main::here/fortunes/haddock1.fortune");
    main::directsay($to, $rep);
}

sub cmd_millesa {
    my ($pkg, $conn, $event, $command, $to) = @_;
    my $rep = fortune("$main::here/fortunes/haddock2.fortune");
    main::directsay($to, $rep);
}

sub cmd_kaamelot {
    my ($pkg, $conn, $event, $command, $to) = @_;
    my $patt = "";
    if ($command =~ /kaamelot (.*)$/) {
        $patt = $1;
    }
    my $rep = fortune("$main::here/fortunes/kaamelot.fortune $patt");
    main::directsay($to, $rep);
}

sub corvo {
    my ($pkg, $conn, $event, $command, $to, $corvopt) = @_;
    my $startPhrase = fortune("$main::here/fortunes/".$corvopt."_gabarits");

    while ($startPhrase =~ /\[.\]/) {
        # n+a
        if ($startPhrase =~ /\[n\] \[a\]/) {
            my $nom = "";
            my $adj = "";
            my $n1 = fortune("$main::here/fortunes/".$corvopt."_noun");
            my $a1 = fortune("$main::here/fortunes/".$corvopt."_adjective");
            $n1 =~ s/\n//g;
            $a1 =~ s/\n//g;
            $n1 =~ /^(.)(.*),(.),(.)$/;
            my $i = $1;
            my $n = "$1"."$2";
            my $g = $3;
            if ($i =~ /[aeiouyh]/) {
                $nom = "l'$n";
            } else {
                if ($g == 1) {
                    $nom = "le $n";
                } else {
                    $nom = "la $n";
                }
            }
            $a1 =~ /^(.*),(.*)$/;
            if ($g == 1) {
                $adj = $1;
            } else {
                $adj = $2;
            }
            $startPhrase =~ s/\[n\] \[a\]/$nom $adj/;
        } elsif ($startPhrase =~ /\[n\]/) {
        # n
            my $nom = "";
            my $adj = "";
            my $n1 = fortune("$main::here/fortunes/".$corvopt."_noun");
            $n1 =~ s/\n//g;
            $n1 =~ /^(.)(.*),(.),(.)$/;
            my $i = $1;
            my $n = "$1"."$2";
            my $g = $3;
            if ($i =~ /[aeiouyh]/) {
                $nom = "l'$n";
            } else {
                if ($g == 1) {
                    $nom = "le $n";
                } else {
                    $nom = "la $n";
                }
            }
            $startPhrase =~ s/\[n\]/$nom/;
        }

        # v
        if ($startPhrase =~ /\[v\]/) {
            my $v1 = fortune("$main::here/fortunes/".$corvopt."_verb");
            $v1 =~ s/\n//g;
            $startPhrase =~ s/\[v\]/$v1/;
        }

        # v (avec d' ou de)
        if ($startPhrase =~ /\[d\]/) {
            my $d1 = fortune("$main::here/fortunes/".$corvopt."_verb");
            $d1 =~ s/\n//g;
            my $verb = "";
            $d1 =~ /^(.)(.*)$/;
            my $i = $1;
            if ($i =~ /[aeiouyh]/) {
                $verb = "d'$d1";
            } else {
                $verb = "de $d1";
            }
            $startPhrase =~ s/\[d\]/$verb/;
        }

        # m
        if ($startPhrase =~ /\[m\]/) {
            my $m1 = fortune("modules/bagolu/fortunes/".$corvopt."_noun_m");
            $m1 =~ s/\n//g; 
            $startPhrase =~ s/\[m\]/$m1/;
        }
        # f
        if ($startPhrase =~ /\[f\]/) {
            my $f1 = fortune("modules/bagolu/fortunes/".$corvopt."_noun_f");
            $f1 =~ s/\n//g; 
            $startPhrase =~ s/\[f\]/$f1/;
        }


    }
    main::directsay($to, $startPhrase);
}


sub cmd_corvo {
    my ($pkg, $conn, $event, $command, $to) = @_;
    corvo($pkg,$conn, $event, $command, $to,"corvophraseur");
}

sub cmd_propale {
    my ($pkg, $conn, $event, $command, $to) = @_;
    corvo($pkg,$conn, $event, $command, $to,"corvopropale");
}

sub cmd_bofhus {
    my ($pkg, $conn, $event, $command, $to) = @_;
    my $patt = "";
    if ($command=~ /!bofhus (.*)$/) { $patt = $1; }
    my $rep = fortune("/usr/share/games/fortunes/bofh-excuses $patt");
    main::directsay($to, $rep);
}

sub cmd_bofhfr {
    my ($pkg, $conn, $event, $command, $to) = @_;
    my $patt = "";
    if ($command=~ /!bofhfr (.*)$/) { $patt = $1; }
    my $rep = fortune("$main::here/fortunes/bofh-excuses-fr.fortune $patt");
    main::directsay($to, $rep);
}

sub cmd_shadok {
    my ($pkg, $conn, $event, $command, $to) = @_;
    my $patt = "";
    if ($command=~ /!shadok (.*)$/) { $patt = $1; }
    my $rep = fortune("$main::here/fortunes/MAURICE-SHADOK $patt");
    main::directsay($to, $rep);
}

sub cmd_lyon {
    my ($pkg, $conn, $event, $command, $to) = @_;
    my $patt = "";
    if ($command=~ /!lyon (.*)$/) { $patt = $1; }
    my $rep = fortune(
	"$main::here/fortunes/fortune.plaisante-sagesse-lyonnaise $patt");
    main::directsay($to, $rep);
}

sub cmd_savoie {
    my ($pkg, $conn, $event, $command, $to) = @_;
    my $patt = "";
    if ($command=~ /!savoie (.*)$/) { $patt = $1; }
    my $rep = fortune("$main::here/fortunes/fortune.patois-savoyard $patt");
    main::directsay($to, $rep);
}

sub cmd_tontons {
    my ($pkg, $conn, $event, $command, $to) = @_;
    my $patt = "";
    if ($command=~ /!tontons* (.*)$/) { $patt = $1; }
    my $rep = fortune("$main::here/fortunes/tonton.fortune $patt");
    main::directsay($to, $rep);
}

sub cmd_fortune {
    my ($pkg, $conn, $event, $command, $to) = @_;

    my $fortunetext = $command;
    my $ret = "";
    my $from = $event->nick;
    print "== cmd_fortune $fortunetext\n";
    if ($fortunetext =~ /^.*fortune add (.*?) (.*)$/) {
        my $fortuneid = $1;
        my $fortunesay = $2;
        if ($command =~ /\[(.*)\]/) {
            $from = $1;
        }
        $ret = "Ok, j'ai not ce que $fortuneid a dit ;)";
        print "$ret\n";
        open (F, ">> $main::here/fortunes/MAURICE-FORTUNE");
        print F "$fortunesay\n    -- $fortuneid\n%\n";
	close(F);
        system("cd $main::here/fortunes && make");
    } elsif ($fortunetext =~ /^.*fortune stat/) {
        $ret = "Statistiques des fortunes : \n".
        `grep "    --" $main::here/fortunes/MAURICE-FORTUNE | awk -F "-- " '{print \$2}' | sort -i | uniq -ic | sort -n`;
    } else {
        my $patt = "";
        if ($fortunetext =~ /^.*fortune (.*)$/) {
            $patt = $1;
        }
        $ret = fortune("$main::here/fortunes/MAURICE-FORTUNE $patt");
        print "$ret\n";
    }
    main::directsay($to,$ret);
}

1;
