# -*- perl -*-
# $Id: messages.pm,v 1.1 2009/07/29 09:53:51 cbellot Exp $

package modules::messages;
my $modulename = "messages";

our @messages=();
our $messages_file = "$main::here/fortunes/messages";

sub new {
    my $self = {};
    bless $self;
    return $self;
}
sub load { 
    main::dprint "## ".$modulename."::load : loading"; 
    @messages = ();
    if (-f $messages_file) {
        open(F,"<$messages_file");
        while(<F>) {
            chomp();
            push @messages, $_;
        }
        close(F);
    }
}
sub unload { 
    main::dprint "## ".$modulename."::unload : unloading"; 
    open(F,">$messages_file");
    foreach (@messages) {
        print F $_."\n";
    }
    close(F);
}

sub message_delete {
    my ($dest) = @_;
    my @newlist = grep(!/^$dest /, @messages,);
    open(F,">$messages_file");
    foreach (@newlist) {
	print F $_."\n";
    }
    close(F);
    @messages = @newlist;
}
sub cmd_message {
    my ($pkg, $conn, $event, $say, $to) = @_;
    my $from = $event->nick;
    if ($say =~ /^!msg add (.*?) (.*)$/) {
	my ($dest, $msg) = ($1, $2);
	my $time = time();
        open (F, ">> $messages_file");
        print F "$dest $from $time $msg\n";
        close(F);
        push @messages, "$dest $from $time $msg";
        $ret = "message for $dest recorded";
    } elsif ($say =~ /^!msg del (.*?)$/) {
        &message_delete($1);
        $ret = "message for $1 removed";
    } else {
        $ret = "Messages : \n";
        foreach (@messages) { 
	    /^(.*?) (.*?) (\d+) (.*)$/;
	    $ret .= "  $2 to $1 : $4\n"; 
	}
        $ret =~ s/, $//;
    }
    main::directsay($to,$ret);
}

sub cmd_messagesnif {
    my ($pkg, $conn, $event, $say, $to) = @_;
    my $from = $event->nick;

    return if ($say eq "-!- has quit -!-");

    my @msgtotell = grep(/^$from /, @messages,);
    if ($#msgtotell+1) {
	main::directsay($to,"$from: you have message(s):");
        foreach (@msgtotell) { 
	    /^.*? (.*?) (\d+) (.*)$/;
	    my ($who,$when,$what) = ($1,$2,$3);
	    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
		localtime($when);
	    $mon += 1; $year += 1900;
	    my $date = sprintf("%4d-%.02d-%.02d,%.02d:%.02d",
		$year,$mon,$mday, $hour,$min,$sec);
	    my $ret = "[$date] <$who> $from: $what\n"; 
	    main::directsay($to,$ret);
	}
	&message_delete($from);
    }
}

1;
